/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.adaptors.basicexample.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.adaptors.basicexample.servlet.ServletListener;
import se.kth.md.adaptors.basicexample.BasicAdaptorConstants;
import se.kth.md.adaptors.basicexample.resources.ExtendedRequirement;

// Start of user code imports
// End of user code

// Start of user code preClassCode
// End of user code

// Start of user code classAnnotations
// End of user code
@OslcNamespace(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE)
@OslcName(BasicAdaptorConstants.SOFTWAREPRODUCT)
@OslcResourceShape(title = "SoftwareProduct Resource Shape", describes = BasicAdaptorConstants.TYPE_SOFTWAREPRODUCT)
public class SoftwareProduct
    extends AbstractResource
    implements ISoftwareProduct
{
    // Start of user code attributeAnnotation:title
    // End of user code
    private String title;
    // Start of user code attributeAnnotation:lineOfCode
    // End of user code
    private Integer lineOfCode;
    // Start of user code attributeAnnotation:requirements
    // End of user code
    private HashSet<Link> requirements = new HashSet<Link>();
    
    // Start of user code classAttributes
    // End of user code
    // Start of user code classMethods
    // End of user code
    public SoftwareProduct()
           throws URISyntaxException
    {
        super();
    
        // Start of user code constructor1
        // End of user code
    }
    
    public SoftwareProduct(final URI about)
           throws URISyntaxException
    {
        super(about);
    
        // Start of user code constructor2
        // End of user code
    }
    
    public SoftwareProduct(final String serviceProviderId, final String resourceId)
           throws URISyntaxException
    {
        this (constructURI(serviceProviderId, resourceId));
        // Start of user code constructor3
        // End of user code
    }
    
    public static URI constructURI(final String serviceProviderId, final String resourceId)
    {
        String basePath = ServletListener.getServicesBase();
        Map<String, Object> pathParameters = new HashMap<String, Object>();
        pathParameters.put("serviceProviderId", serviceProviderId);
        pathParameters.put("resourceId", resourceId);
        String instanceURI = "bd-services/{serviceProviderId}/resources/softwareProducts/{resourceId}";
    
        final UriBuilder builder = UriBuilder.fromUri(basePath);
        return builder.path(instanceURI).buildFromMap(pathParameters);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId , final String label)
    {
        return new Link(constructURI(serviceProviderId, resourceId), label);
    }
    
    public static Link constructLink(final String serviceProviderId, final String resourceId)
    {
        return new Link(constructURI(serviceProviderId, resourceId));
    }
    
    public String toString()
    {
        return toString(false);
    }
    
    public String toString(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toString_init
        // End of user code
    
        if (asLocalResource) {
            result = result + "{a Local SoftwareProduct Resource} - update SoftwareProduct.toString() to present resource as desired.";
            // Start of user code toString_bodyForLocalResource
            // End of user code
        }
        else {
            result = getAbout().toString();
        }
    
        // Start of user code toString_finalize
        // End of user code
    
        return result;
    }
    
    public String toHtml()
    {
        return toHtml(false);
    }
    
    public String toHtml(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toHtml_init
        // End of user code
    
        if (asLocalResource) {
            result = toString(true);
            // Start of user code toHtml_bodyForLocalResource
            // End of user code
        }
        else {
            result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
        }
    
        // Start of user code toHtml_finalize
        // End of user code
    
        return result;
    }
    
    public void addRequirements(final Link requirements)
    {
        this.requirements.add(requirements);
    }
    
    
    // Start of user code getterAnnotation:title
    // End of user code
    @OslcName("title")
    @OslcPropertyDefinition(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE + "title")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    public String getTitle()
    {
        // Start of user code getterInit:title
        // End of user code
        return title;
    }
    
    // Start of user code getterAnnotation:lineOfCode
    // End of user code
    @OslcName("lineOfCode")
    @OslcPropertyDefinition(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE + "lineOfCode")
    @OslcDescription("")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.Integer)
    @OslcReadOnly(false)
    public Integer getLineOfCode()
    {
        // Start of user code getterInit:lineOfCode
        // End of user code
        return lineOfCode;
    }
    
    // Start of user code getterAnnotation:requirements
    // End of user code
    @OslcName("requirements")
    @OslcPropertyDefinition(BasicAdaptorConstants.BASICDOMAIN_NAMSPACE + "requirements")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.Resource)
    @OslcRange({BasicAdaptorConstants.TYPE_EXTENDEDREQUIREMENT})
    @OslcReadOnly(false)
    public HashSet<Link> getRequirements()
    {
        // Start of user code getterInit:requirements
        // End of user code
        return requirements;
    }
    
    
    // Start of user code setterAnnotation:title
    // End of user code
    public void setTitle(final String title )
    {
        // Start of user code setterInit:title
        // End of user code
        this.title = title;
    
        // Start of user code setterFinalize:title
        // End of user code
    }
    
    // Start of user code setterAnnotation:lineOfCode
    // End of user code
    public void setLineOfCode(final Integer lineOfCode )
    {
        // Start of user code setterInit:lineOfCode
        // End of user code
        this.lineOfCode = lineOfCode;
    
        // Start of user code setterFinalize:lineOfCode
        // End of user code
    }
    
    // Start of user code setterAnnotation:requirements
    // End of user code
    public void setRequirements(final HashSet<Link> requirements )
    {
        // Start of user code setterInit:requirements
        // End of user code
        this.requirements.clear();
        if (requirements != null)
        {
            this.requirements.addAll(requirements);
        }
    
        // Start of user code setterFinalize:requirements
        // End of user code
    }
    
    
    static public String titleToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:titleToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"title\">title: </LABEL>";
    
        // Start of user code "Mid:titleToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"title\" type=\"text\" style=\"width: 400px\" id=\"title\" >";
        // Start of user code "Finalize:titleToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String lineOfCodeToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:lineOfCodeToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"lineOfCode\">lineOfCode: </LABEL>";
    
        // Start of user code "Mid:lineOfCodeToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"lineOfCode\" type=\"text\" style=\"width: 400px\" id=\"lineOfCode\" >";
        // Start of user code "Finalize:lineOfCodeToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String requirementsToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:requirementsToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"requirements\">requirements: </LABEL>";
    
        // Start of user code "Mid:requirementsToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:requirementsToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    
    public String titleToHtml()
    {
        String s = "";
    
        // Start of user code titletoHtml_init
        // End of user code
    
        s = s + "<label for=\"title\"><strong>title</strong>: &nbsp;</LABEL>";
    
        // Start of user code titletoHtml_mid
        // End of user code
    
        try {
            if (title == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + title.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code titletoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String lineOfCodeToHtml()
    {
        String s = "";
    
        // Start of user code lineOfCodetoHtml_init
        // End of user code
    
        s = s + "<label for=\"lineOfCode\"><strong>lineOfCode</strong>: &nbsp;</LABEL>";
    
        // Start of user code lineOfCodetoHtml_mid
        // End of user code
    
        try {
            if (lineOfCode == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + lineOfCode.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code lineOfCodetoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String requirementsToHtml()
    {
        String s = "";
    
        // Start of user code requirementstoHtml_init
        // End of user code
    
        s = s + "<label for=\"requirements\"><strong>requirements</strong>: &nbsp;</LABEL>";
    
        // Start of user code requirementstoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            for(Link next : requirements) {
                s = s + "<li>";
                s = s + (new ExtendedRequirement (next.getValue())).toHtml(false);
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code requirementstoHtml_finalize
        // End of user code
    
        return s;
    }
    
    
}
